'''
Alicja year 1 cs project (make a game with python with tk and no other external libraries)
zip file in this folder contains all of these files
Designed for 1920x1080, but will run in a window
'''
from tkinter import Tk,Canvas,PhotoImage
import time,math,json,pickle
import obj_player,obj_enemy,obj_bullet,launcher

#entire game state stored in list:
game_state = []
frame = 0

#initialise variables for movement
left_held = 0
right_held = 0
up_held = 0
down_held = 0
z_held = 0
velocity_x = 0
velocity_y = 0
player_speed = 2
beam_charge = 100
add_screen = 0

b_held = 0
s_held = 0
p_held = 0

intro_frame = 0 # set to 6 for testing - set to 0 for final version
current_score = 0
multiplier = 10

user_text = ''
user_name = ''


#game process will handle updating the game state and drawing to screen in sequence
def game_process():
    '''
    This function runs every frame and will, in sequence:
    - Update the positions of player
    - Update the positions of other objects
    - Check if any objects are killing the player or should be destroyed
    - Update score
    - Create new objects from timeline and from other objects
    - Draw all objects to screen and handle the player's beam
    - Start the function again roughly 16ms from when it was run
    '''
    global game_state,frame,timeline,z_held,beam_charge,current_score,multiplier,b_held,s_held,p_held,add_screen,destination,settings

    time_frame = time.time()
    frame += 1

    #update player position
    if obj_player.invuln < 87:
        obj_player.x += velocity_x
        obj_player.y += velocity_y
        if obj_player.x > 600:
            obj_player.x = 600
        if obj_player.x < 0:
            obj_player.x = 0
        if obj_player.y > 400:
            obj_player.y = 400
        if obj_player.y < 0:
            obj_player.y = 0

    #update positions of other objects
    for obj in game_state:
        obj.update()

    #check objects that should be destroyed
    new_explosions = [obj for obj in game_state if obj.health <= 0 and type(obj).__name__ != 'Explosion']
    game_state = [obj for obj in game_state if obj.health > 0]
    
    #add score
    for obj in new_explosions:
        if obj.base_score > 0:
            current_score += obj.base_score * multiplier
            #the line below could be used to calculate bonus but seeing as the player can only shoot forwards,
            #i might as well just check the difference in x, since this is likely more expensive.
            #bonus = math.sqrt((obj.x-obj_player.x)**2 + (obj.y-obj_player.y)**2) 
            bonus = 400 - abs(obj.x - obj_player.x)
            if bonus < 0:
                bonus = 0
            elif bonus > 300:
                bonus = 300
            current_score += int(bonus/30 * multiplier)
            multiplier += 1
        game_state.append(obj_enemy.Explosion(obj.x,obj.y))

    #check objects that are killing the player
    if [obj for obj in game_state if obj.miss == 1] != []:
        #remove things that are killing the player(?)
        game_state = [obj for obj in game_state if obj.miss == 0]
        
        #kill the player:
        if obj_player.invuln == 0:
            obj_player.invuln = 100
            obj_player.life += -1
            beam_charge = -12

    
    #create new objects from timeline
    if timeline != []:
        while timeline[0][0] <= frame:
            new_obj = timeline.pop(0)
            eval('game_state.append(obj_enemy.' + str(new_obj[1]) + '(' + str(new_obj[2]) + ',' + str(new_obj[3]) + '))')

    #create new objects from other objects
    new_outputs = [obj for obj in game_state if obj.output != []]
    for enemy in new_outputs:
        for bullet in enemy.output:
            eval('game_state.append(obj_bullet.' + str(bullet[0]) + '(' + str(bullet[1:]).strip('[]') + '))')

    #draw all objects to screen
    game_canvas.delete('all') #clear canvas
    
    #draw player
    if obj_player.invuln == 0:
        game_canvas.create_image(obj_player.x,obj_player.y,image=ship_img)
    else:
        #for 14 frames, show the explosion animation, and then flash the ship sprite to show invulnerability
        if obj_player.invuln >= 87:
            game_canvas.create_image(obj_player.x,obj_player.y,image=explode_img[int((100-obj_player.invuln)/2)])
        elif obj_player.invuln % 2 == 0 and obj_player.life > 0:
            game_canvas.create_image(obj_player.x,obj_player.y,image=ship_img)
        obj_player.invuln += -1

    #update beam
    if z_held == 0 and beam_charge < 100:
        beam_charge += 1
        multiplier = 10
    if z_held == 1 and beam_charge > 0:
        beam_charge += -1
        if obj_player.beam_frame < 4:
            obj_player.beam_frame += 1
    else:
        if obj_player.beam_frame > 0:
            obj_player.beam_frame += -1

    #draw beam
    if obj_player.beam_frame > 0:
        game_canvas.create_image(obj_player.x + 15,obj_player.y,image=beam_img[obj_player.beam_frame - 1],anchor='w')
    if beam_charge >= 50:
        game_canvas.create_rectangle(0,390,600 * (beam_charge/100),400,fill='green')
    elif beam_charge >= 25:
        game_canvas.create_rectangle(0,390,600 * (beam_charge/100),400,fill='orange')
    else:
        game_canvas.create_rectangle(0,390,600 * (beam_charge/100),400,fill='red')

    #draw each bullet and enemy
    for obj in game_state:
        obj_type = type(obj).__name__
        if obj_type == 'Straight':
            game_canvas.create_oval(obj.x - obj.hitbox,obj.y - obj.hitbox,obj.x + obj.hitbox,obj.y + obj.hitbox,fill='pink', outline='red')
        elif obj_type == 'Basic':
            game_canvas.create_image(obj.x,obj.y,image=basic_img)
        elif obj_type == 'Explosion':
            game_canvas.create_image(obj.x,obj.y,image=explode_img[int(obj.lifetime)])
        elif obj_type == 'Fast':
            game_canvas.create_image(obj.x,obj.y,image=fast_img)
        elif obj_type == 'DelayHoming':
            game_canvas.create_oval(obj.x - obj.hitbox,obj.y - obj.hitbox,obj.x + obj.hitbox,obj.y + obj.hitbox,fill='powder blue', outline='blue')
        elif obj_type == 'Complex':
            game_canvas.create_image(obj.x,obj.y,image=complex_img)
        
        
        elif obj_type == 'Boss':
            game_canvas.create_image(obj.x,obj.y,image=boss_img[0])
            if obj.lifetime > 150 and obj.lifetime < 777:
                add_screen = obj.lifetime - 150
                if add_screen > 600:
                    add_screen = 600
                game.geometry(str(int(600+add_screen))+"x400+0+0")    

        else:
            game_canvas.create_line(600,0,obj.x,obj.y,fill='white')


    #draw score to screen
    game_canvas.create_text(5,380,text='0'*(6-len(str(current_score))) + str(current_score),anchor='w',fill='white')
    game_canvas.create_text(5,370,text=str(multiplier/10) + 'x',anchor='w',fill='white')

    #check if player is dead
    if obj_player.life > 0:
        if b_held == 1 and settings[0] == False:
            destination = 'b'
            game.after(1,bp_hit)
        elif p_held == 1 and settings[0] == False:
            destination = 'p'
            game.after(1,bp_hit)
        else: #call the function again once up to 16ms has passed
            game.after(int(16 + ((time_frame - time.time())*1000)),game_process)
    else:
        if settings[0] == True and settings[1] == True:
            destination = 'i'
        else:
            destination = 'l'
        game.after(1,bp_hit)
        pass #this will go to leaderboard screen later

def bp_hit():
    '''Makes sure the player is not pressing a key before moving onto the next screen'''
    global destination,b_held,p_held,z_held,user_name
    game_canvas.delete('all')
    game.geometry("600x400+0+0")
    if b_held == 1 or p_held == 1 or z_held == 1:
        game.after(16,bp_hit)
    else:
        if destination == 'b':
            game.after(1,bosskey)
        elif destination == 'p':
            game.after(1,pause_menu)
        elif destination == 'i':
            user_name = ''
            game.after(1,initials)
        else:
            game.after(1,leaderboard)

def initials():
    '''This screen asks the user for input with initials, which are 3 characters'''
    global user_name,current_score
    print('init')
    game_canvas.delete('all')
    game_canvas.create_text(300,50,text='ENTER INITIALS',fill='white')
    game_canvas.create_text(300,200,text=user_name,fill='white')
    if len(user_name) >= 3:
        with open('leaderboard.txt','a') as lb_file:
            lb_file.write(user_name[0:3].upper() + str(current_score) + '\n')
        game.after(60,leaderboard)
    else:
        game.after(16,initials)

def leaderboard():
    '''Shows the leaderboard of top 10 players. The game is then stuck on purpose'''
    game_canvas.delete('all')
    game_canvas.create_text(300,50,text='HALL OF POSTAL RECORDS',fill='white')
    lb_list = []
    with open('leaderboard.txt','r') as lb_file:
        lb_list = lb_file.read().split('\n')
    lb_list = [[record[0:3],record[3:]] for record in lb_list if len(record) > 3]
    lb_list.sort(key=lambda record: int(record[1]),reverse=True)
    for i in range(0,min(10,len(lb_list))):
        game_canvas.create_text(300,80+(24*i),text=str(lb_list[i][0]) + ':  ' + str(lb_list[i][1]),fill='white')

def bosskey():
    '''Displays a work like boss key screen to convince whoever's looking over your shoulder that you're very well behaved'''
    global b_held
    game_canvas.delete('all')
    game_canvas.create_image(0,0,image=bosskey_img,anchor='nw')
    if b_held == 1:
        game.after(1,bp_release)
    else:
        game.after(16,bosskey)

def pause_menu():
    '''Pause menu where the game can be unpaused or saved and quit'''
    global p_held,s_held,game_state,frame,settings
    game_canvas.delete('all')
    game_canvas.create_image(0,0,image=pause_img,anchor='nw')
    if p_held == 1:
        game.after(1,bp_release)
    elif s_held == 1:
        #save and quit
        savegame = settings.copy()
        savegame[4] = game_state
        savegame[5] = frame
        with open('savegame','wb') as savefile:
            pickle.dump(savegame,savefile)
        game.destroy()
    else:
        game.after(16,pause_menu)

def bp_release():
    '''Returns the game to the main game state before returning, making sure they aren't immediately going to open the pause screen'''
    global b_held,p_held,add_screen
    game_canvas.delete('all')
    game.geometry(str(int(600+add_screen))+"x400+0+0")
    if b_held == 1 or p_held == 1:
        game.after(16,bp_release)
    else:
        game.after(1,game_process)



def get_focus():
    '''
    This is just called once so the window is brought to the front when it appears.
    Obviously any more than once would be incredibly frustrating which is why it;s a separate function.
    '''
    game.focus_force()
    game.after(200,show_title)
    boss_canvas.create_image(0,0,image=boss_img[1],anchor='nw')

def show_title():
    '''
    This function displays the title, which will call itself and alternate between showing the text and not.
    When z is pressed this moves the game to the intro screen
    '''
    global z_held
    if int((time.time() * 2)) % 2 == 0:
        game_canvas.delete('all')
        game_canvas.create_image(0,0,image=title_img,anchor='nw')
        game_canvas.create_text(300,360,text='HIT KEY Z TO BEGIN',fill='white')
    else:
        game_canvas.delete('all')
        game_canvas.create_image(0,0,image=title_img,anchor='nw')
    if z_held == 0:
        game.after(50,show_title)
    else:
        game.after(1,start_intro)

def start_intro():
    '''
    Slowly fades in the intro text over the course of 10 seconds.
    The text doesn't really mean anything so it doesn't matter if you can't read it in time that's part of the joke
    '''
    global intro_frame
    game_canvas.delete('all')
    game_canvas.create_image(0,0,image=intro_img[intro_frame],anchor='nw')
    intro_frame += 1
    if intro_frame == 7:
        game.after(3000,game_process)
    else:
        game.after(1000,start_intro)

#handle user input in this section
def update_velocity():
    '''Sets the velocity based on the arrow keys being held at the moment'''
    global left_held,right_held,up_held,down_held,velocity_x,velocity_y
    direction_x = right_held - left_held
    direction_y = down_held - up_held

    if direction_x != 0 and direction_y != 0:
        #this section normalises inputs for diagonal movement
        #this means that speed should be the same going either cardinally or diagonally
        velocity_x = math.sqrt(2)/2 * player_speed * direction_x
        velocity_y = math.sqrt(2)/2 * player_speed * direction_y
    else:
        velocity_x = player_speed * direction_x
        velocity_y = player_speed * direction_y


def key_event(event):
    '''This function handles all key press inputs, called whenever a key is pressed or released'''
    global left_held,right_held,up_held,down_held,z_held,b_held,s_held,p_held,user_text,user_name,beam_charge,game_state
    #event.type = 3 when key released, so will be set to 0
    #event.type = 2 when key is pressed, so will be set to 1
    if int(event.type) == 2:
        if len(str(event.keysym)) == 1:
            user_name += str(event.keysym)
        user_text += str(event.keysym)
        if len(user_text) > 1000:
            user_text = ''
        if settings[0] == False:
            if 'UpUpDownDownLeftRightLeftRight' in user_text:
                obj_player.life = 99
            if 'laser' in user_text:
                beam_charge = 4000
            if 'clear' in user_text:
                game_state = [obj for obj in game_state if type(obj).__name__ == 'Boss']
                user_text = ''
    if event.keysym == 'Left':
        left_held = 3 - int(event.type)
    elif event.keysym == 'Right':
        right_held = 3 - int(event.type)
    elif event.keysym == 'Up':
        up_held = 3 - int(event.type)
    elif event.keysym == 'Down':
        down_held = 3 - int(event.type)
    elif event.keysym == 'z':
        z_held = 3 - int(event.type)
    elif event.keysym == 'b':
        b_held = 3 - int(event.type)
    elif event.keysym == 's':
        s_held = 3 - int(event.type)
    elif event.keysym == 'p':
        p_held = 3 - int(event.type)
    update_velocity()

#game launcher to set settings
settings = launcher.get_settings()
game_state = settings[4]
frame = settings[5]

if settings[1] == True:
    with open('timeline.json','r') as timeline_file:
        timeline = json.load(timeline_file)
else:
    with open('reduced.json','r') as timeline_file:
        timeline = json.load(timeline_file)

timeline = [obj for obj in timeline if obj[0] > frame]

#create game window and start all game processes
#if the launcher was closed by the X this just won't happen
if settings[3] == True:
    game = Tk()
    game.geometry("600x400+0+0")
    game.resizable(False,False)
    game.title("SPS: Dissemination Shooting Game")

    game_canvas = Canvas(game,background='black',width=600,height=400)
    boss_canvas = Canvas(game,background='black',width=600,height=400)
    #game_canvas.pack(expand=True,fill='both')
    game_canvas.place(x=0,y=0,anchor='nw')
    boss_canvas.place(x=600,y=0,anchor='nw')
    time_start = time.time()
    game.bind('<KeyPress>',key_event)
    game.bind('<KeyRelease>',key_event)

    #create images for use in the game
    ship_img = PhotoImage(file='ship.png')
    beam_img = [PhotoImage(file='beam1.png'),PhotoImage(file='beam2.png'),PhotoImage(file='beam3.png'),PhotoImage(file='beam4.png')]
    title_img = PhotoImage(file='title.png')
    basic_img = PhotoImage(file='basic.png')
    fast_img = PhotoImage(file='fast.png')
    complex_img = PhotoImage(file='complex.png')
    boss_img = [PhotoImage(file='espsLEFT2.png'),PhotoImage(file='espsRIGHT2.png')]
    pause_img = PhotoImage(file='pause.png')
    bosskey_img = PhotoImage(file='bosskey.png')
    intro_img = []
    for i in range(0,7):
        filename = 'intro' + str(i) + '.png'
        intro_img.append(PhotoImage(file=str(filename)))
    explode_img = []
    for i in range(1,8):
        filename = 'explode' + str(i) + '.png'
        explode_img.append(PhotoImage(file=str(filename)))
    
    game.after(10,get_focus)
    #game_process()

    game.mainloop()
